Bug 417211 - apparent mem-leaks in XFCE 4.4.1 ....
apparent mem-leaks in XFCE 4.4.1 ....
Status: CLOSED CURRENTRELEASE
Product: Fedora
Classification: Fedora
Component: xfdesktop (Show other bugs)
8
All Linux
low Severity medium
: ---
: ---
Assigned To: Kevin Fenzi
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2007-12-09 08:43 EST by William A. Mahaffey III
Modified: 2008-01-10 21:21 EST (History)
0 users

See Also:
Fixed In Version: 4.4.2
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2007-12-23 18:02:30 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
output from various commands as requested .... (22.80 KB, text/plain)
2007-12-09 16:41 EST, William A. Mahaffey III
no flags Details
output from top, sorted by RES RAM use .... (5.69 KB, text/plain)
2007-12-19 20:01 EST, William A. Mahaffey III
no flags Details

  None (edit)
Description William A. Mahaffey III 2007-12-09 08:43:40 EST
Description of problem: This is a repost of an earlier bug about mem-leaks in
XFCE. xfdesktop & xfce4-menu-plug are apparently leaking memory, to the tune of
about 25 MB/day. I just upgraded from FC6 (-> FC7 ->FC8), where bug 375921 had
been filed, then closed. When I 1st logged in after the install, they were using
about 20 MB total between the 2 of them, they are up to about 60 MB after 2 days
logged in.


Version-Release number of selected component (if applicable): XFCE 4.4.1


How reproducible: install XFCE under FC8 (64-bit), log in, & wait :-) ....


Steps to Reproduce: see above
1.
2.
3.
  
Actual results: 2 components are at ~57 MB of RAM used after 2 days logged in,
were at ~20 MB initially, and slowly increasing day-by-day.


Expected results: no increase in RAM usage over time, or else rise to some
plateau level & stay there.


Additional info:uname -a:Linux Opty165A 2.6.18-1.2798.fc6 #1 SMP Mon Oct 16
14:39:22 EDT 2006 x86_64 x86_64 x86_64 GNU/Linux
Comment 1 William A. Mahaffey III 2007-12-09 08:45:24 EST
Aaaaaaaaacccccckkkkk !!!! WRONG uname info above :-(. How about:

Linux AthlonCube.CFD.COM 2.6.23.1-42.fc8 #1 SMP Tue Oct 30 13:18:33 EDT 2007
x86_64 x86_64 x86_64 GNU/Linux
Comment 2 Kevin Fenzi 2007-12-09 12:12:24 EST
ok, lets try and track this down...

can you provide: 

1. 'rpm -qa | grep xf' 

2. 'ps -axuww' 

3. If you create a new user and login as them does that user have the problem?

4. Do you have any panel plugins enabled? Or just the stock setup?

5. Do you have any wallpapers/backgrounds set? Do you have it changing them in a
list?
Comment 3 William A. Mahaffey III 2007-12-09 16:41:34 EST
Created attachment 282371 [details]
output from various commands as requested ....
Comment 4 William A. Mahaffey III 2007-12-09 16:44:25 EST
nothing fancy here, no panel plugins AFAIK, no wallpaper (chosen by me, might be
some default choice), not changing, etc. *Very* plain vanilla, see attached,
shows various rxvt's & tcsh's & that's *IT* :-(. Up to ~65 MB now, from ~20 at
login ....
Comment 5 Kevin Fenzi 2007-12-09 17:36:00 EST
Hum. You seem to have .fc6 versions of Xfce still installed?
Can you do a 'yum update' and make sure everything updates and logout and back on?

Note that I have a x86_64 laptop here, using F8 Xfce rpms and am not seeing this
memory issue. Also, I can't find any reports of it upstream other than a report
about the menu-plugin having a memory leak for checking and unchecking the 'show
icons in menus' checkbox. 

Comment 6 William A. Mahaffey III 2007-12-10 08:30:56 EST
I recently upgraded the box from FC6 (--> FC7 --> FC8) & anaconda didn't choose
to upgrade those (XFCE.fc6) packages, I figured it would have if it wanted to
.... The 'newer' FC8 packages are the same XFCE version (4.4.1) IIRC, is there
really any reason to believe there are any differences ?

When you log you laptop in, do you stay logged in for days/weeks ? It appears
that that is the time frame necessary for the leaks to begin manifesting,
although I have been logged in for about 4 days now & am seeing them ....

From top, this A.M:

top - 07:35:09 up 3 days, 21:19,  1 user,  load average: 0.00, 0.02, 0.00
Tasks: 193 total,   1 running, 189 sleeping,   0 stopped,   3 zombie
Cpu(s):  2.7%us,  0.8%sy,  0.0%ni, 96.5%id,  0.0%wa,  0.0%hi,  0.0%si,  0.0%st
Mem:   1997288k total,  1978076k used,    19212k free,    25360k buffers
Swap:  2031608k total,       56k used,  2031552k free,  1402892k cached

  PID USER      PR  NI  VIRT  RES  SHR S %CPU %MEM    TIME+  COMMAND           
                                             
11167 wam       20   0 7141m  64m  21m S    1  3.3   0:11.42 firefox-bin       
                                              
11134 wam       20   0 4228m  56m  20m S    0  2.9   0:05.28 thunderbird-bin   
                                              
 3100 root      20   0  184m  42m  10m S    3  2.2  14:53.14 X                 
                                              
 3231 wam       20   0 1203m  41m  11m S    0  2.1   3:29.17 xfdesktop         
                                              
 3248 wam       20   0  147m  37m 8928 S    0  1.9   3:07.50 xfce4-menu-plug   
                                              
 3236 wam       20   0 2357m  24m  13m S    0  1.2   0:14.91 ekiga             
                                              
 3233 wam       20   0 2137m  17m 8292 S    0  0.9   0:13.70 Thunar            
                                              
 1702 root      20   0 23524  15m  412 S    0  0.8   0:00.09 restorecond       
                                              
 3255 wam       20   0  172m  15m 7500 S    0  0.8   0:00.30 python            
                                              
 3229 wam       20   0  227m  14m 8832 S    0  0.8   0:06.42 xfce-mcs-manage   
                                              
 5252 wam       20   0 61108  14m 2572 S    0  0.7   0:00.54 ssh               
                                              

i.e. xfdesktop & xfce4-menu-plug up to about 78 MB bwtween them ....
Comment 7 Kevin Fenzi 2007-12-10 11:30:53 EST
All of Fedora does NOT fit on a single DVD. Xfce is not on the dvd. 
So if you upgrade via the dvd media only, you don't get an upgraded Xfce. 
You need to run a 'yum upgrade' and pick up the new Xfce packages, right now you
are running the same fc6 ones you were before. ;) 
Comment 8 William A. Mahaffey III 2007-12-10 11:49:45 EST
OK, here goes, again:

[root@AthlonCube:/etc, Mon Dec 10, 10:51 AM] 1163 # !954
yum -y check-update >& LIST.updates
[root@AthlonCube:/etc, Mon Dec 10, 10:52 AM] 1164 # ll -tr LIST.*
1867584 1120 -rw-r--r-- 1 root root 1134994 Oct 14 09:07 LIST.IntcCompilers
1867847    8 -rw-r--r-- 1 root root     568 Oct 23 15:37 LIST.jre.sun
1867146  888 -rw-r--r-- 1 root root  901075 Dec  5 16:25 LIST.all
1867450  128 -rw-r--r-- 1 root root  120416 Dec  5 19:54 LIST.installed
1867583  780 -rw-r--r-- 1 root root  786927 Dec  5 19:54 LIST.available
1931521   32 -rw-r--r-- 1 root root   26481 Dec 10 10:52 LIST.updates
[root@AthlonCube:/etc, Mon Dec 10, 10:52 AM] 1165 # grep -i xf LIST.updates
libxfce4mcs.x86_64                       4.4.1-3.fc8            fedora          
libxfce4mcs-devel.x86_64                 4.4.1-3.fc8            fedora          
libxfce4util.x86_64                      4.4.1-3.fc8            fedora          
libxfce4util-devel.x86_64                4.4.1-3.fc8            fedora          
libxfcegui4.x86_64                       4.4.1-3.fc8            fedora          
libxfcegui4-devel.x86_64                 4.4.1-3.fc8            fedora          
xfce-mcs-manager.x86_64                  4.4.1-3.fc8            fedora          
xfce-mcs-manager-devel.x86_64            4.4.1-3.fc8            fedora          
xfce-mcs-plugins.x86_64                  4.4.1-3.fc8            fedora          
xfce-utils.x86_64                        4.4.1-3.fc8            fedora          
xfce4-icon-theme.noarch                  4.4.1-3.fc8            fedora          
xfce4-panel.x86_64                       4.4.1-4.fc8            fedora          
xfce4-sensors-plugin.x86_64              0.10.0-6.fc8           fedora          
xfce4-session.x86_64                     4.4.1-2.fc8            fedora          
xfce4-session-engines.x86_64             4.4.1-2.fc8            fedora          
xfdesktop.x86_64                         4.4.1-3.fc8            fedora          
xfwm4.x86_64                             4.4.1-3.fc8            fedora          
xorg-x11-xfs.x86_64                      1:1.0.5-1.fc8          fedora          
[root@AthlonCube:/etc, Mon Dec 10, 10:52 AM] 1166 # yum -y upgrade xfce
Loading "fastestmirror" plugin
Loading mirror speeds from cached hostfile
Setting up Upgrade Process
Could not find update match for xfce
No Packages marked for Update
[root@AthlonCube:/etc, Mon Dec 10, 10:53 AM] 1167 #

i.e. it doesn't think it has anything to upgrade :-) ....
Comment 9 Kevin Fenzi 2007-12-10 12:09:04 EST
That won't work. You are asking it to upgrade a package called "xfce". There is
no such package. 

You need to either do: 'yum upgrade' and pull in all updates (preferred). 
Or you could try: 
'yum groupupdate XFCE' 
Comment 10 William A. Mahaffey III 2007-12-10 13:22:58 EST
Very well. The groupupdate didn't work, tried to install a bunch of unnecessary
i386 crap & got into a dependency problem. I updated xfce*.x86_64,
xfdesktop.x86_64 & xfvwm4.x86_64. We'll see. I am frankly quite skeptical that
upgrading from XFCE 4.4.1.FC6 to XFCE 4.4.1.FC8 will do anything except waste my
time doing the update, but we'll see ....
Comment 11 William A. Mahaffey III 2007-12-19 20:01:26 EST
Created attachment 290087 [details]
output from top, sorted by RES RAM use ....

This is the new baseline RAM use, moments after login. We'll see if it grows as
it did w/ 4.4.1 ....
Comment 12 William A. Mahaffey III 2007-12-19 20:02:50 EST
4.4.1.FC8 was a waste of time, same symptoms ....
Comment 13 Kevin Fenzi 2007-12-19 20:12:08 EST
You are seeing memory grow in 1 minute? (the time between your last comments)

Note that 4.4.2 is out now and has been pushed to stable updates. 
You could try upgrading to that, as I mentioned it has a bunch of bugfixes. 

I'm really not sure whats going on here. I don't see this issue here on any of
my machines, nor do any other Xfce users I have asked about it. 

I wonder if it could be some strange video hardware interaction. Whats your
video card chipset/driver? 

Also, have you tried a clean newly created user as suggested in comment #2?
(This would rule out some config corruption in your user settings).

I guess the next step would be to come up with a script you can run that will
run those items under something like valgrind and report whats allocating memory
without freeing it. I can look at writing up something for you... 
Comment 14 William A. Mahaffey III 2007-12-19 20:45:34 EST
Sorry, part of my comments got lost when I added the file. I will recap:

XFCE 4.4.1.FC8 was indeed a waste of time, same problem as 4.4.1.FC6. I then
upgraded to 4.4.2 today & logged out & back in. What I posted was the baseline
(moments after login, presumably virgin/pristine RAM state) w/ 4.4.2. Sorry for
the confusion. Whenever I put in additional comments & upload a file in the same
stroke, the comments get lost :-/ ....
Comment 15 William A. Mahaffey III 2007-12-19 20:51:27 EST
let me try to clarify further. I observed the 4.4.1.FC8 for about 6 days, it was
up to ~140 MB each for xfdesktop & xfce-menu-plugin, same as 4.4.1.FC6. These
symptoms take a few days to manifest, not just a few hours. I commonly leave my
machines logged in for weeks, & that is when the RAM usage gets really
objectionable.
Comment 16 William A. Mahaffey III 2007-12-23 17:22:36 EST
Well .... a little Christmas cheer :-). After 4+ days logged in under XFCE
4.4.2, top shows:

top - 16:19:39 up 17 days,  6:03,  1 user,  load average: 0.04, 0.03, 0.00
Tasks: 187 total,   1 running, 186 sleeping,   0 stopped,   0 zombie
Cpu(s):  0.2%us,  0.2%sy,  0.0%ni, 99.7%id,  0.0%wa,  0.0%hi,  0.0%si,  0.0%st
Mem:   1997288k total,  1587008k used,   410280k free,    99428k buffers
Swap:  2031608k total,       56k used,  2031552k free,   905036k cached

  PID USER      PR  NI  VIRT  RES  SHR S %CPU %MEM    TIME+  COMMAND
 4466 wam       20   0 9030m  46m  21m S    0  2.4   0:04.80 thunderbird-bin
20038 root      20   0  185m  42m 8288 S    0  2.2  11:59.00 X
20184 wam       20   0 2342m  31m  20m S    0  1.6   0:16.81 ekiga
20176 wam       20   0 1171m  16m  11m S    0  0.8   0:06.60 xfdesktop
20174 wam       20   0  219m  15m 9164 S    0  0.8   0:09.56 xfce-mcs-manage
 1702 root      20   0 23524  15m  412 S    0  0.8   0:00.40 restorecond
20183 wam       20   0  200m  15m 9680 S    0  0.8   1:15.68 xfce4-panel
20225 wam       20   0  172m  15m 7488 S    0  0.8   0:00.48 python
21794 wam       20   0 61108  14m 2572 S    0  0.7   0:00.46 ssh
 5461 wam       20   0 61108  14m 2580 S    0  0.7   0:00.51 ssh
21787 wam       20   0 61108  14m 2572 S    0  0.7   0:00.40 ssh
 5465 wam       20   0 61108  14m 2580 S    0  0.7   0:00.36 ssh
 5468 wam       20   0 61108  14m 2580 S    0  0.7   0:00.38 ssh
27082 wam       20   0 61108  14m 2572 S    0  0.7   0:00.38 ssh
 5473 wam       20   0 61108  14m 2520 S    0  0.7   0:00.37 ssh
21851 wam       20   0 61108  14m 2516 S    0  0.7   0:02.60 ssh
21801 wam       20   0 61108  14m 2516 S    0  0.7   0:00.46 ssh
 5455 wam       20   0 61108  14m 2520 S    0  0.7   0:00.45 ssh
20185 wam       20   0  182m  14m 9992 S    0  0.7   0:03.31 xfce4-menu-plug
 1973 root      20   0  162m  14m 1932 S    0  0.7   0:00.45 cupsd
27394 wam       20   0  120m  13m 6244 S    0  0.7   0:08.01 xfce4-sensors-p
20170 wam       20   0  180m  12m 8216 S    0  0.6   0:05.24 xfce4-session
20178 wam       20   0  133m  11m 7668 S    0  0.6   0:00.48 Thunar
20186 wam       20   0 1192m  10m 8684 S    0  0.5   0:00.13 evolution-alarm
20227 wam       20   0  198m  10m 8300 S    0  0.5   0:00.05 nm-applet
20175 wam       20   0 97.7m 8524 6112 S    0  0.4   0:10.75 xfwm4
20197 wam       20   0 3048m 7556 5744 S    0  0.4   0:00.05 evolution-data-
 5267 wam       20   0  190m 6000 4860 S    0  0.3   0:00.03 gpilotd
18956 wam       20   0 31804 5396 1760 S    0  0.3   0:00.95 gconfd-2
20287 wam       20   0 31524 5208 1372 S    0  0.3   0:01.54 rxvt
20271 wam       20   0 31420 5204 1368 S    0  0.3   0:01.74 rxvt
20694 wam       20   0 31436 5200 1368 S    0  0.3   0:00.70 rxvt
20283 wam       20   0 31448 5196 1368 S    0  0.3   0:00.35 rxvt
 2406 root      20   0  128m 5132 4120 S    0  0.3   0:00.21 gdm-binary
20172 wam       20   0  127m 4752 3380 S    0  0.2   0:47.10 gnome-screensav
20279 wam       20   0 30920 4636 1368 S    0  0.2   0:00.37 rxvt
20246 wam       20   0 30788 4476 1372 S    0  0.2   0:00.37 rxvt
20266 wam       20   0 30788 4452 1368 S    0  0.2   0:00.31 rxvt
20259 wam       20   0 30656 4408 1368 S    0  0.2   0:00.34 rxvt
20293 wam       20   0 91936 3800 3036 S    0  0.2   0:00.15 gnome-vfs-daemo

or virtually identical (for xfdesktop & xfce-menu-plugin) RAM usage as when I
1st logged in :-). free -m shows:

[wam@AthlonCube, ~, 4:26:19pm] 75 % free -m
             total       used       free     shared    buffers     cached
Mem:          1950       1596        353          0         97        886
-/+ buffers/cache:        612       1337
Swap:         1983          0       1983
[wam@AthlonCube, ~, 4:26:23pm] 76 %

i.e. about 600 MB used, still rather portly, but standing pat, not growing w/
each passing day. I think there is definitely something amiss in 4.4.1, but for
4.4.2, I think you can mark this one:  BUSTED !!!!

Merry Christmas.
Comment 17 Kevin Fenzi 2007-12-23 18:02:30 EST
Excellent. Glad to hear it... 

feel free to re-open or file a new bug if you spot anything else. 
Comment 18 William A. Mahaffey III 2008-01-10 21:21:59 EST
Update: after a couple of weeks logged in, I have:

top - 20:22:14 up 35 days, 10:03,  1 user,  load average: 0.03, 0.07, 0.06
Tasks: 194 total,   1 running, 189 sleeping,   0 stopped,   4 zombie
Cpu(s):  0.2%us,  0.3%sy,  0.0%ni, 99.5%id,  0.0%wa,  0.0%hi,  0.0%si,  0.0%st
Mem:   1997288k total,  1919668k used,    77620k free,    91844k buffers
Swap:  2031608k total,       56k used,  2031552k free,  1050084k cached

  PID USER      PR  NI  VIRT  RES  SHR S %CPU %MEM    TIME+  COMMAND           
                                             
21111 wam       20   0 7230m  76m  22m S    0  3.9   1:07.33 firefox-bin       
                                              
20176 wam       20   0 1229m  75m  11m S    0  3.9   7:33.65 xfdesktop         
                                              
20185 wam       20   0  241m  73m 9972 S    0  3.7   6:37.26 xfce4-menu-plug   
                                              
21261 wam       20   0 8086m  61m  21m S    0  3.1   0:11.85 thunderbird-bin   
                                              
20038 root      20   0  195m  53m  10m S    0  2.7  68:39.68 X                 
                                              
20184 wam       20   0 2349m  32m  20m S    0  1.7   1:17.37 ekiga             
                                              
27394 wam       20   0  144m  30m 6204 S    0  1.6   0:42.17 xfce4-sensors-p   
                                              
20178 wam       20   0 2130m  20m 9832 S    0  1.1   0:18.39 Thunar            
                                              
20645 root      20   0 26360  15m  320 S    0  0.8   0:00.21 restorecond       
                                              
20183 wam       20   0  208m  15m 9628 S    0  0.8   4:07.33 xfce4-panel       
                                              
20174 wam       20   0  226m  15m 8684 S    0  0.8   0:24.39 xfce-mcs-manage   
                                              
20225 wam       20   0  172m  15m 7500 S    0  0.8   0:01.53 python            
                                              
27082 wam       20   0 61108  14m 2572 S    0  0.8   0:00.66 ssh               
                                              
21794 wam       20   0 61108  14m 2572 S    0  0.7   0:00.83 ssh               
                                              
 5461 wam       20   0 61108  14m 2580 S    0  0.7   0:00.58 ssh               
                                              
21787 wam       20   0 61108  14m 2572 S    0  0.7   0:00.58 ssh               
                                              
 5465 wam       20   0 61108  14m 2580 S    0  0.7   0:00.56 ssh               
                                              
 5468 wam       20   0 61108  14m 2580 S    0  0.7   0:00.72 ssh               
                                              
 5455 wam       20   0 61108  14m 2520 S    0  0.7   0:00.73 ssh               
                                              
 5473 wam       20   0 61108  14m 2520 S    0  0.7   0:00.87 ssh               
                                              
21851 wam       20   0 61108  14m 2516 S    0  0.7   0:03.17 ssh               
                                              
21801 wam       20   0 61108  14m 2516 S    0  0.7   0:01.02 ssh               
                                              
 1973 root      20   0  162m  14m 1932 S    0  0.7   0:00.57 cupsd             
                                              
20170 wam       20   0  187m  12m 8380 S    0  0.6   0:21.19 xfce4-session     
                                              
20186 wam       20   0 1256m  10m 8700 S    0  0.5   0:00.32 evolution-alarm   
                                              
20227 wam       20   0  198m  10m 8300 S    0  0.5   0:00.06 nm-applet         
                                              
20175 wam       20   0 99.3m 9.8m 6148 S    0  0.5   0:45.32 xfwm4             
                                              
20197 wam       20   0 3049m 8248 5744 S    0  0.4   0:00.13 evolution-data-   
                                              
 5267 wam       20   0  190m 6012 4872 S    0  0.3   0:00.04 gpilotd           
                                              
20172 wam       20   0  127m 5484 3560 S    0  0.3   4:30.83 gnome-screensav   
                                              
32075 wam       20   0 31800 5396 1756 S    0  0.3   0:01.68 gconfd-2          
                                              
20694 wam       20   0 31436 5228 1368 S    0  0.3   0:04.44 rxvt              
                                              
20287 wam       20   0 31524 5216 1372 S    0  0.3   0:02.10 rxvt              
                                              
20246 wam       20   0 31448 5208 1372 S    0  0.3   0:01.31 rxvt              
                                              
20251 wam       20   0 31528 5208 1368 S    0  0.3   0:01.84 rxvt              
                                              
20271 wam       20   0 31420 5204 1368 S    0  0.3   0:02.75 rxvt              
                                              
20259 wam       20   0 31448 5196 1368 S    0  0.3   0:00.79 rxvt              
                                              
20266 wam       20   0 31448 5196 1368 S    0  0.3   0:01.10 rxvt              
                                              
20283 wam       20   0 31448 5196 1368 S    0  0.3   0:01.05 rxvt              
                                              

i.e. about 150 MB between xfdesktop & xfce-menu-plugin (compare w/ above
immediately after login). This took quite a bit longer to manifest, but looks
like there is still something here. uname gives:

[root@AthlonCube:/etc, Thu Jan 10, 08:24 PM] 1400 # uname -a
Linux AthlonCube.CFD.COM 2.6.23.1-42.fc8 #1 SMP Tue Oct 30 13:18:33 EDT 2007
x86_64 x86_64 x86_64 GNU/Linux
[root@AthlonCube:/etc, Thu Jan 10, 08:24 PM] 1401 #

XFCE is 4.4.2-1.fc8.

Note You need to log in before you can comment on or make changes to this bug.